package cn.iocoder.yudao.framework.common.thealgorithms.bitmanipulation;

///**
// * Checks whether a number is even
// * @author Bama Charan Chhandogi (https://github.com/BamaCharanChhandogi)
// */
//
//public final class IsEven {
//    private IsEven() {
//    }
//    public static boolean isEven(int number) {
//        return (number & 1) == 0;
//    }
//}

/**
 * 检查一个数字是否为偶数
 * @作者 Bama Charan Chhandogi (https://github.com/BamaCharanChhandogi)
 */

public final class IsEven {
    private IsEven() {
    }
    // 判断数字是否为偶数
    public static boolean isEven(int number) {
        // 如果数字与 1 的位与运算结果为 0，则为偶数
        return (number & 1) == 0;
    }
}

