package cn.iocoder.yudao.framework.common.thealgorithms.bitmanipulation;

///**
// * Numbers Different Signs
// * @author Bama Charan Chhandogi
// */
//
//public final class NumbersDifferentSigns {
//    private NumbersDifferentSigns() {
//    }
//
//    public static boolean differentSigns(int num1, int num2) {
//        return (num1 ^ num2) < 0;
//    }
//}

/**
 * 判断两个数字是否符号不同
 * @作者 Bama Charan Chhandogi
 */

public final class NumbersDifferentSigns {
    private NumbersDifferentSigns() {
    }

    // 判断两个数字是否符号不同
    public static boolean differentSigns(int num1, int num2) {
        // 通过对两个数字进行异或操作，然后检查结果是否小于 0 来判断它们的符号是否不同
        return (num1 ^ num2) < 0;
    }
}

